# General Settings
# The Prefix that will be used on SOLR, Website and Database instances.
$Prefix = "sc910xp1"
# The root folder with the license file deployment config files and WDP packages.
$SCInstallRoot = "C:\Temp\XP1"
# The location of the Sitecore license file.
$LicenseFile = "$SCInstallRoot\license.xml"
# The URL of the SOLR Service, must be HTTPS
$SolrUrl = "https://solr_host:8983/solr"
# The Folder that Solr has been installed in.
$SolrRoot = "C:\Solr-7.2.1"
# The Name of the Solr Service.
$SolrService = "solr-7.2.1"
# A SQL user with sysadmin privileges.
$SqlAdminUser = "sa"
# The password for $SqlAdminUser.
$SqlAdminPassword = "Password12345"
#The random string key used for establishing connection with IdentityService
$ClientSecret = "SIF-Default"
# The name for the certificate.
$CertificateName = "$prefix.xconnect"

# Hosts names
# The DNS name or IP of the Solr computer.
$SolrComputerName = ""
# The DNS name or IP of the SQL Instance.
$SqlServer = ""
# The DNS name of the Identity Server computer.
$IdentityServerComputerName = ""
# The DNS name of the Content Management computer.
$CMComputerName = ""
# The DNS name of the Content Delivery computer.
$CDComputerName = ""
# The DNS name of the Processing computer.
$PrcComputerName = ""
# The DNS name of the Reporting computer.
$RepComputerName = ""
# The DNS name of the Collection computer.
$CollectionComputerName = ""
# The DNS name of the Collection Search computer.
$CollectionSearchComputerName = ""
# The DNS name of the Reference Data computer.
$ReferenceDataComputerName = ""
# The DNS name of the Marketing Automation computer.
$MarketingAutomationComputerName = ""
# The DNS name of the Marketing Automation Reporting computer.
$MarketingAutomationReportingComputerName = ""
# The DNS name of the Cortex Processing computer.
$CortexProcessingComputerName = ""
# The DNS name of the Cortex Reporting computer.
$CortexReportingComputerName = ""

# Site Names
# The name for the XConnect processing engine service.
$CortexProcessingSitename = "$Prefix.cort.prc"
# The name for the XConnect collection site.
$CollectionSitename = "$Prefix.collection"
# The name for the search site.
$CollectionSearchSitename = "$Prefix.collectionsearch"
# The name for the Marketing Automation site.
$MarketingAutomationSitename = "$Prefix.ma"
# The name for the Marketing Automation Reporting site.
$MarketingAutomationReportingSitename = "$Prefix.ma.rep"
# The name for the Reference Data site.
$ReferenceDataSitename = "$Prefix.refdata"
# The name for the XConnect reporting servcice.
$CortexReportingSitename = "$Prefix.cort.rep"
# The name for the Reporting site.
$RepSitename = "$Prefix.rep"
# The name for the Processing site.
$PrcSitename = "$Prefix.prc"
# The name for the Content Management site.
$CMSitename = "$Prefix.cm"
# The name for the Content Delivery site.
$CDSitename = "$Prefix.cd"
# Identity Server site name.
$IdentityServerSiteName = "$prefix.identityserver"

# Paths to WDP packages
# The path to the Sitecore Content Management package.
$CMPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_cm.scwdp.zip").FullName
# The path to the Sitecore Content Delivery package.
$CDPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_cd.scwdp.zip").FullName
# The path to the Identity Server package.
$IdentityServerPackage = (Get-ChildItem "$SCInstallRoot\Sitecore.IdentityServer 2.0.0 rev. * (OnPrem)_identityserver.scwdp.zip").FullName
# The path to the Sitecore Content Reporting package.
$RepPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_rep.scwdp.zip").FullName
# The path to the Sitecore Content Processing package.
$PrcPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_prc.scwdp.zip").FullName
# The path to the XConnect Collection package.
$CollectionPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_xp1collection.scwdp.zip").FullName
# The path to the XConnect Collection Search package.
$CollectionSearchPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_xp1collectionsearch.scwdp.zip").FullName
# The path to the XConnect Processing engine package.
$CortexProcessingPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_xp1cortexprocessing.scwdp.zip").FullName
# The path to the XConnect Marketing Automation package.
$MarketingAutomationPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_xp1marketingautomation.scwdp.zip").FullName
# The path to the XConnect Marketing Automation Reporting package.
$MarketingAutomationReportingPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_xp1marketingautomationreporting.scwdp.zip").FullName
# The path to the XConnect Reporting package.
$CortexReportingPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_xp1cortexreporting.scwdp.zip").FullName
# The path to the XConnect Reference Data package.
$ReferenceDataPackage = (Get-ChildItem "$SCInstallRoot\Sitecore 9.1.0 rev. * (OnPrem)_xp1referencedata.scwdp.zip").FullName

# Service URLs
# The URL for the Identity Server password recovery, this should be the URL of the CM Instance.
$PasswordRecoveryUrl = "http://$CMSitename"
# The URL of the Identity Authority
$SitecoreIdentityAuthority = "https://$IdentityServerComputerName"
# Allowed CORS Origins, urls of all clients should be added here
$allowedCorsOrigins = "https://$CMComputerName"
# The URL for the Processing service.
$ProcessingService = "http://$PrcComputerName"
# The URL for the Reporting service.
$ReportingService = "https://$RepComputerName"
# The URL of the Cortex Reporting Service
$CortexReportingService = "https://$CortexReportingComputerName"
# The URL of the XConnect Collection service.
$XConnectCollectionService = "https://$CollectionComputerName"
# The URL of the XConnect Reference Data service
$XConnectReferenceDataService = "https://$ReferenceDataComputerName"
# The URL of the Marketing Automaton Service
$MarketingAutomationOperationsService = "https://$MarketingAutomationComputerName"
# The URL of the Marteting Automation Reporting Service
$MarketingAutomationReportingService = "https://$MarketingAutomationReportingComputerName"
# The URL for the XConnect Search Service.
$XConnectCollectionSearchService = "https://$CollectionSearchComputerName"
# The URL of the Machine Learning service
$MachineLearningServerUrl = ""

#Getting Hosts User credentials:
Write-Host "Hosts user name: "
$HostsUserName = Read-Host
Write-Host "Hosts user password: "
$HostsUserPassword = Read-Host
Clear-Host

# Install XM1 via combined partials file.
$DistributedDeploymentParams = @{
    Path = "$SCInstallRoot\XP1-Distributed.json"
    ComputerUserName = $HostsUserName
    ComputerPassword = $HostsUserPassword
    IdentityServerComputerName = $IdentityServerComputerName
    SolrComputerName = $SolrComputerName
    CollectionComputerName = $CollectionComputerName
    CollectionSearchComputerName = $CollectionSearchComputerName
    ReferenceDataComputerName = $ReferenceDataComputerName
    MarketingAutomationComputerName = $MarketingAutomationComputerName
    MarketingAutomationReportingComputerName = $MarketingAutomationReportingComputerName
    CortexProcessingComputerName = $CortexProcessingComputerName
    CortexReportingComputerName = $CortexReportingComputerName
    CMComputerName = $CMComputerName
    CDComputerName = $CDComputerName
    PrcComputerName = $PrcComputerName
    RepComputerName = $RepComputerName
    LicenseFile = $LicenseFile
    IdentityServerSiteName = $IdentityServerSiteName
    Prefix = $Prefix
    CollectionPackage = $CollectionPackage
    CollectionSearchPackage = $CollectionSearchPackage
    CortexProcessingPackage = $CortexProcessingPackage
    MarketingAutomationPackage = $MarketingAutomationPackage
    MarketingAutomationReportingPackage = $MarketingAutomationReportingPackage
    CortexReportingPackage = $CortexReportingPackage
    ReferenceDataPackage = $ReferenceDataPackage
    CDPackage = $CDPackage
    CMPackage = $CMPackage
    RepPackage = $RepPackage
    PrcPackage = $PrcPackage
    IdentityServerPackage = $IdentityServerPackage
    CortexProcessingSitename = $CortexProcessingSitename
    CollectionSitename = $CollectionSitename
    CollectionSearchSitename = $CollectionSearchSitename
    MarketingAutomationSitename = $MarketingAutomationSitename
    MarketingAutomationReportingSitename = $MarketingAutomationReportingSitename
    ReferenceDataSitename = $ReferenceDataSitename
    CortexReportingSitename = $CortexReportingSitename
    CDSitename = $CDSitename
    CMSitename = $CMSitename
    RepSitename = $RepSitename
    PrcSitename = $PrcSitename
    ProcessingService = $ProcessingService
    ReportingService = $ReportingService
    CortexReportingService = $CortexReportingService
    XConnectCollectionSearchService = $XConnectCollectionSearchService
    XConnectCollectionService = $XConnectCollectionService
    XConnectReferenceDataService = $XConnectReferenceDataService
    MarketingAutomationOperationsService = $MarketingAutomationOperationsService
    MarketingAutomationReportingService = $MarketingAutomationReportingService
    AllowedCorsOrigins = $AllowedCorsOrigins  
    MachineLearningServerUrl = $MachineLearningServerUrl
    ClientSecret = $ClientSecret
    SitecoreIdentityAuthority = $SitecoreIdentityAuthority
    PasswordRecoveryUrl = $PasswordRecoveryUrl
    SqlAdminUser = $SqlAdminUser
    SqlAdminPassword = $SqlAdminPassword
    SqlServer = $SqlServer
    SolrUrl = $SolrUrl
    SolrService = $SolrService
    CertificateName = $CertificateName
}

Push-Location $SCInstallRoot

Install-SitecoreConfiguration @DistributedDeploymentParams -Verbose *>&1 | Tee-Object XP1-Distributed.log

Pop-Location
